film/urls.py
from django.urls import path

from . import views

app_name = 'film'

urlpatterns = [
    # path('', views.index, name='list'),
    path('', views.FilmView.as_view(), name='list'),
    # path('detail/<int:pk>', views.detail, name='detail'),
    path('detail/<int:pk>', views.FilmDetailView.as_view(), name='detail'),
    # path('create-form/', views.create_form, name='list'),
    path('create-form/', views.AddFilmView.as_view(), name='add'),
    # path('edit-form/<int:pk>', views.edit_form, name='list'),
    path('edit-form/<int:pk>', views.UpdateFilmView.as_view(), name='update'),

    path('delete/<int:pk>', views.DeleteFilmView.as_view(), name = 'delete')
]

sipi/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings


urlpatterns = [
    path('admin/', admin.site.urls),
    path('berita/', include('berita.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('', include('home.urls')),
    path('', include('watchlist.urls')),
    path('', include('forum.urls')),
    path('film/', include('film.urls')),
    path('account/', include('account.urls')),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

ulasan/urls.py
from django.urls import path

from . import views

app_name = 'ulasan'

urlpatterns = [
    path('seeulasan/<int:pk>', views.seeulasan, name='seeulasan'),
    path('formulasan/<int:pk>', views.makereview, name='formulasan'),
    path('updateulasan/<int:pk>', views.updatereview, name='updateulasan'),
    path('confdeleulasan/<int:pk>', views.deletereview, name='deleteulasan'),
]

ulasan/models.py
from django.db import models
from django.core.validators import MaxValueValidator, MinValueValidator
from django.conf import settings
from film.models import Film

User = settings.AUTH_USER_MODEL
# Create your models here.
class Reviews(models.Model):
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    movie = models.ForeignKey(Film, blank=True, null=True, on_delete=models.CASCADE)
    rating = models.IntegerField(validators=[MaxValueValidator(10), MinValueValidator(0)])
    body = models.TextField()
    
    def __str__(self):
        return (str(self.movie) + '-' + str(self.author))

ulasan/forms.py
from django import forms
from django.forms import ModelForm
from django.forms.widgets import Textarea
from ulasan.models import Reviews

class ReviewForm(forms.ModelForm):
    class Meta:
        model = Reviews
        fields = [
            'rating',
            'body'
        ]

        widgets = {
            'rating': forms.TextInput(attrs={'class':'form-control', 'placeholder':'rating / 10'}),
            'body': forms.Textarea(attrs={'class':'form-control'})
        }

ulasan/views.py
from ulasan.models import Reviews
from film.models import Film
from django.shortcuts import render, redirect
from ulasan.forms import ReviewForm

from django.contrib import messages
from django.contrib.auth.decorators import login_required
# Create your views here.


def seeulasan(request, pk):
    movie = Film.objects.get(pk=pk)

    if(not request.user.is_authenticated):
        messages.add_message(request, messages.WARNING, 'Please Log In')
        return redirect('home:home')

    reviewlist = Reviews.objects.filter(movie=movie, author=request.user)
    if not reviewlist:
        return redirect('/ulasan/formulasan/'+str(pk))

    review = Reviews.objects.get(movie=movie, author=request.user)
    context = {'pk': pk, 'movie': movie, 'review': review}

    return render(request, 'ulasan/seeulasan.html', context)


def makereview(request, pk):
    form = ReviewForm()
    movie = Film.objects.get(pk=pk)
    context = {'pk': pk, 'form': form, 'movie': movie}

    if(not request.user.is_authenticated):
        messages.add_message(request, messages.WARNING, 'Please Log In')
        return redirect('home:home')

    if request.method == 'POST':
        form = ReviewForm(request.POST)
        if form.is_valid():
            review = form.save(commit=False)
            review.movie = movie
            review.author = request.user
            review.save()
            return redirect('/ulasan/seeulasan/'+str(pk))
        else:
            context['form'] = ReviewForm()
    review = Reviews.objects.filter(movie=movie, author=request.user)
    if review:
        return redirect('home:home')
    return render(request, 'ulasan/formulasan.html', context)


def updatereview(request, pk):
    movie = Film.objects.get(pk=pk)
    review = Reviews.objects.get(movie=movie, author=request.user)
    form = ReviewForm(instance=review)

    context = {'pk': pk, 'form': form, 'movie': movie}

    if(not request.user.is_authenticated):
        messages.add_message(request, messages.WARNING, 'Please Log In')
        return redirect('home:home')

    if request.method == 'POST':
        form = ReviewForm(request.POST or None, instance=review)
        if form.is_valid():
            form.save()
            return redirect('/ulasan/seeulasan/'+str(pk))
        else:
            context['form'] = form = ReviewForm(
                request.POST or None, instance=review)
    return render(request, 'ulasan/updateulasan.html', context)


def deletereview(request, pk):
    movie = Film.objects.get(pk=pk)
    review = Reviews.objects.get(movie=movie, author=request.user)
    context = {'movie':movie, 'review':review, 'pk':pk}

    if (request.method == 'POST'):
        review.delete()
        return redirect('film:list')
    return render(request, 'ulasan/confirmdeleteul.html', context)

ulasan/templates/ulasan/confirmdeleteul.html
<!DOCTYPE html>

{% extends 'base.html' %} {% load static %} {% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/home.css' %}" />
<link rel="stylesheet" type="text/css" href="{% static 'ulasan/ulasan.css' %}" />
{% endblock css %} {% block title %} Lihat Ulasan {% endblock title %}
{% block content %}
<br /><br />

<div class="d-flex justify-content-center" style="margin-top: 20rem;">
    <div>
        <div>
            <br>
            <h2> Apakah Anda Yakin menghapus ulasan anda mengenai {{ movie.judul_film }} ? </h2>
            <br>
        </div>
        <div class='d-flex justify-content-center'>
            <div class="container">
                <div class='row text-center'>
                    <div class='col'>
                        <a href="{% url 'ulasan:seeulasan' pk=movie.pk %}">
                            <button type="button" class="btn btn-secondary">
                                tidak
                            </button>
                        </a>
                    </div>
                    <div class='col'>
                        <form method='POST' action="{% url 'ulasan:deleteulasan' pk=movie.pk %}" class="form-group">
                            {% csrf_token %}
                            <button type="submit" name="button" class="btn btn-danger">ya</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock content %} {% block script %} {% endblock script %}

ulasan/templates/ulasan/formulasan.html
<!DOCTYPE html>

{% extends 'base.html' %} {% load static %} {% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/home.css' %}" />
<link rel="stylesheet" type="text/css" href="{% static 'ulasan/ulasan.css' %}" />

{% endblock css %} {% block title %} Form Ulasan {% endblock title %}
{% block content %}
<br /><br />

<div class="container">
    <div>
        <br />
        <div>
            <h1>{{ movie.judul_film }}</h1>
        </div>
        <div class="row">
            <br />
            <div class='col col-lg-3'>
                <img src='{{movie.poster}}' class='img-fluid'>
            </div>
            <br />
            <div class='col'>
                <p>
                    {{movie.sinopsis}}
                </p>
            </div>
        </div>
        <br>
        <div class="col">
            <h2>Anda belum mengulas {{ movie.judul_film }}.</h2>
            <h4>Tulis ulasan</h4>
            <div class="form-group">
                <form method='POST' action="{% url 'ulasan:formulasan' pk=movie.pk %}">
                    {% csrf_token %}
                    {{ form.as_p }}

                    <button type="submit" name="button" class="btn btn-secondary">Submit</button>
                </form>
            </div>
            <br>
        </div>
    </div>
</div>

{% endblock content %} {% block script %} {% endblock script %}

ulasan/templates/ulasan/seeulasan.html
<!DOCTYPE html>

{% extends 'base.html' %} {% load static %} {% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/home.css' %}" />
<link rel="stylesheet" type="text/css" href="{% static 'ulasan/ulasan.css' %}" />
{% endblock css %} {% block title %} Lihat Ulasan {% endblock title %}
{% block content %}
<br /><br />

<div class="container">
    <div>
        <div>
            <br>
                <h1>{{ movie.judul_film }}</h1>
            </div>
        <div class="row">
            <br />
            <div class="col col-lg-3">
                <img src='{{movie.poster}}' class='img-fluid'>
            </div>
            <br />
            <div class='col'>
                <p>
                    {{movie.sinopsis}}
                </p>
            </div>
        </div>
        <br>
        <div class="col">
            <h2>Ulasan anda</h2>
            <div>
                <div><span style='font-size: 50px;'>{{ review.rating }}</span> / 10</div>
                <br />
                <div>
                    <p>
                        {{ review.body }}
                    </p>
                </div>
            </div>
            <div class="row">
                <div class="col col-lg-3">
                    <a href="{% url 'ulasan:updateulasan' pk=movie.pk %}">
                        <button type="button" class="btn btn-secondary">
                            edit ulasan
                        </button>
                    </a>
                </div>
                <div class="col">
                    <a href="{% url 'ulasan:deleteulasan' pk=movie.pk %}">
                        <button type="button" class="btn btn-secondary">
                            hapus ulasan
                        </button>
                    </a>
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock content %} {% block script %} {% endblock script %}

ulasan/templates/ulasan/updateulasan.html
<!DOCTYPE html>

{% extends 'base.html' %} {% load static %} {% block css %}
<link rel="stylesheet" type="text/css" href="{% static 'css/home.css' %}" />
<link rel="stylesheet" type="text/css" href="{% static 'ulasan/ulasan.css' %}" />

{% endblock css %} {% block title %} Form Ulasan {% endblock title %}
{% block content %}
<br /><br />

<div class="container">
    <div>
        <div>
            <br>
            <h1>{{ movie.judul_film }}</h1>
        </div>
        <div class="row">

            <br />
            <div class='col col-lg-3'>
                <img src='{{movie.poster}}' class='img-fluid'>
            </div>
            <br />
            <div class='col'>
                <p>
                    {{movie.sinopsis}}
                </p>
            </div>
        </div>
        <br>
        <div class="col">
            <h2>Ubah ulasan anda mengenai {{ movie.judul_film }}.</h2>
            <div class="form-group">
                <form method='POST' action="{% url 'ulasan:updateulasan' pk=movie.pk %}" class="form-group">
                    {% csrf_token %}
                    {{ form.as_p }}

                    <button type="submit" name="button" class="btn btn-secondary">Submit</button>
                </form>
            </div>
            <br>
        </div>
    </div>
</div>

{% endblock content %} {% block script %} {% endblock script %}